/*
* Template-File src/main/takatuka/templates/EntityAbstractSearch.vm
*/
package de.ivu.elect.business.wahlvorschlagsperson.boundary;

import java.util.List;

import javax.inject.Inject;

import de.ivu.elect.business.wahlvorschlagsperson.entity.WahlvorschlagsPerson;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.jee.presentation.search.WildcardConverter;

public abstract class AbstractWahlvorschlagsPersonSearch {

  @Inject
  protected transient WahlvorschlagsPersonExtendedDAO dao;

  public AbstractWahlvorschlagsPersonSearch() {
    super();
  }

  public List<WahlvorschlagsPerson> getSearchResult(WahlvorschlagsPersonSearchParameters searchParameters, EagerLoadingCollector<WahlvorschlagsPerson> eagerLoadingCollector) {
    return eagerLoadingCollector.eagerLoad(querySearchResult(searchParameters));
  }

  protected abstract List<WahlvorschlagsPerson> querySearchResult(WahlvorschlagsPersonSearchParameters searchParameters);

  protected String convertSearchPattern(String patternInput) {
    return new WildcardConverter().addAndConvertToJpqlLikeExpression(patternInput);
  }
}
